#ifndef lcd_h
#define lcd_h

#define LCD_CONTROLLER_ST7920

#define LCD_LINES 4
#define LCD_DISP_LENGTH 16

#define LCD_START_LINE1 0x00
#define LCD_START_LINE2 0x10
#define LCD_START_LINE3 0x08
#define LCD_START_LINE4 0x18

#define LCD_DELAY_BOOTUP 45000
#define LCD_DELAY_INIT 150
#define LCD_DELAY_INIT_REP 50
#define LCD_DELAY_BUSY_FLAG 4
#define LCD_DELAY_ENABLE_PULSE 1

#define LCD_CLR 0
#define LCD_HOME 1
#define LCD_ENTRY_MODE 2
#define LCD_ENTRY_INC 1
#define LCD_ENTRY_SHIFT 0
#define LCD_ON 3
#define LCD_ON_DISPLAY 2
#define LCD_ON_CURSOR 1
#define LCD_ON_BLINK 0
#define LCD_MOVE 4
#define LCD_MOVE_DISP 3
#define LCD_MOVE_RIGHT 2
#define LCD_FUNCTION 5
#define LCD_FUNCTION_8BIT 4
#define LCD_FUNCTION_EXTENDED 2
#define LCD_CGRAM 6
#define LCD_DDRAM 7
#define LCD_BUSY 7

#define LCD_ENTRY_DEC 0x04
#define LCD_ENTRY_DEC_SHIFT 0x05
#define LCD_ENTRY_INC_ 0x06
#define LCD_ENTRY_INC_SHIFT 0x07

#define LCD_DISP_OFF 0x08
#define LCD_DISP_ON 0x0c
#define LCD_DISP_ON_BLINK 0x0d
#define LCD_DISP_ON_CURSOR 0x0e
#define LCD_DISP_ON_CURSOR_BLINK 0x0f

#define LCD_FUNCTION_8BIT_BASIC 0x30
#define LCD_FUNCTION_8BIT_EXTENDED 0x36

#define LCD_MOVE_CURSOR_LEFT 0x10
#define LCD_MOVE_CURSOR_RIGHT 0x14
#define LCD_MOVE_DISP_LEFT 0x18
#define LCD_MOVE_DISP_RIGHT 0x1c

#define lcd_puts_P(__s) lcd_puts_p(PSTR(__s))

void lcd_command(uint8_t cmd);
void lcd_data(uint8_t data);
void lcd_gotoxy(uint8_t x, uint8_t y);
void lcd_putc(char c);
void lcd_puts(const char *s);
void lcd_puts_p(const char *progmem_s);
void lcd_init();
void glcd_invert(uint8_t x, uint8_t y, uint8_t len);

#endif /* lcd_h */
